//********************************************************************
//*** ResourcePool/ResourcePool.hh
//*** Copyright (c) 2003-2007 by Markus Winand <mws@fatalmind.com>
//*** $Id: Execute.t.cc,v 1.12 2007/09/19 12:42:38 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

// a very strange include...
// make the test classes available, 
// but will not execute the TEST methods since they are parsed lexically
// from this file only.
// the file will be bigger then required, but taff shit...
#define THIS_IS_A_VERY_STRANGE_INCLUDE
#include "ResourcePool.t.cc"

class MyTestCommandOK: public Command<myType<DefaultThreadedModel> > {
	public:
		MyTestCommandOK() 
		: _called(0)
		{
		};
		void execute(Rec& res) {
			_called++;
		}
		int _called;
	protected:
		virtual Clone* DoClone() const {
			return new MyTestCommandOK(*this);
		}
};

class MyTestCommandEx: public MyTestCommandOK {
	public:
		void execute(Rec& res) {
			MyTestCommandOK::execute(res);
			throw Exception("hirsch");
		}
	protected:
		virtual Clone* DoClone() const {
			return new MyTestCommandEx(*this);
		}
};


class MyTestCommandNoFailoverException: public MyTestCommandOK {
	public:
		void execute(Rec& res) {
			MyTestCommandOK::execute(res);
			throw NoFailoverException("hirsch");
		}
	protected:
		virtual Clone* DoClone() const {
			return new MyTestCommandNoFailoverException(*this);
		}
};


class FunkyEx: public NoFailoverException {
	public:
		FunkyEx()
		: NoFailoverException("funky")
		{
		}
};


class MyTestCommandFunkyEx: public MyTestCommandOK {
	public:
		void execute(Rec& res) {
			MyTestCommandOK::execute(res);
			throw FunkyEx();
		}
};


void TEST_MyTestCommandOK() {
	Fac F("hirsch");
	RP<> p(F);
	MyTestCommandOK cmd;	
	p.execute(cmd);
	assertEqualT(int, cmd._called, 1);
}

void TEST_MyTestCommandEx() {
	Fac F("hirsch");
	ResourcePoolOptions o;
	o.setMaxExecTry(4);
	RP<> p(F, o);
	MyTestCommandEx cmd;	
	try {
		p.execute(cmd);
		assertNotReach();
	} catch (Exception e) {
	}
	assertEqualT(int, cmd._called, 4);
}

void TEST_MyTestCommandNoFailoverEx() {
	Fac F("hirsch");
	ResourcePoolOptions o;
	o.setMaxExecTry(4);
	RP<> p(F, o);
	MyTestCommandNoFailoverException cmd;	
	try {
		p.execute(cmd);
		assertNotReach();
	} catch (Exception e) {
	}
	assertEqualT(int, cmd._called, 1);
}

void TEST_MyTestCommandFunkyEx() {
	Fac F("hirsch");
	ResourcePoolOptions o;
	o.setMaxExecTry(4);
	RP<> p(F, o);
	MyTestCommandFunkyEx cmd;	
	try {
		p.execute(cmd);
		assertNotReach();
	} catch (Exception e) {
	}
	assertEqualT(int, cmd._called, 1);
}
