//********************************************************************
//*** ResourcePool/SQL/SQLBatch.t.cc
//*** Copyright (c) 2003-2007 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLBatch.t.cc,v 1.2 2007/09/06 18:16:49 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

using namespace fatalmind;

void test_SQLBatch_init(RP& p) {
	init(p);
}

void test_SQLBatch_one(RP& p)
{
	RP::Command::SQLExecute cmd(p, "insert into hirsch (id) values (?)");
	RP::Command::SQLBatch   b;
	cmd.bind(0, 1);
	b.add(cmd);
	cmd.bind(0, 2);
	b.add(cmd);
	p.execute(b);
}

void test_SQLBatch_fail(RP& p)
{
	RP::Command::SQLExecute cmd(p, "insert into hirsch (id) values (?)");
	RP::Command::SQLBatch   b;
	cmd.bind(0, 10);
	b.add(cmd);
	cmd.bind(0, 20);
	b.add(cmd);
	b.add(cmd);
	assertTrue(b.getError() == b.end());
	try {
		p.execute(b);
		assertNotReach();
	} catch (...) {
	}

	assertTrue(b.getError() != b.end());
}
