//********************************************************************
//*** ResourcePool/oracle/CommandInterface.cc
//*** Copyright (c) 2003-2007 by Markus Winand <mws@fatalmind.com>
//*** $Id: CommandInterface.cc,v 1.8 2007/09/19 12:42:38 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

/*
 * This file is required since the method below is to be inlined
 * but can't be included in the .hh file since the required include
 * oci.h should not publicy be visible.
 */

#ifndef RESOURCEPOOL_ORACLE_COMMANDINTERFACE_CC
#define RESOURCEPOOL_ORACLE_COMMANDINTERFACE_CC

#ifndef RESOURCEPOOL_ORACLE_COMMANDINTERFACE_HH
#include "CommandInterface.hh"
#endif

#ifndef RESOURCEPOOL_ORACLE_STATEMENTCACHE_HH
#include "StatementCache.hh"
#endif

#ifndef OCI_ORACLE
#include <oci.h>
#endif

namespace fatalmind {
namespace oracle {

template<class TM, template<class> class SLMDC>
void CommandInterface<TM, SLMDC>::execute(oracleResource<TM>& hand) {
    StatementCache sthcache;
    _execute(hand, sthcache);
}

} // namespace oracle
} // namespace fatalmind
#endif
